-- Pulsing Circle

-- define Properties
property("Max_Radius",INTEGER, 5) -- Maximum size of the circle
property("Foreground", GRADIENT, 0.0, 255, 0, 0, 1.0, 0, 0, 255) -- Circle Gradient
property("Background", COLOUR, 0,0,0) -- Background colour
property("Reveal", BOOLEAN, true) -- Changes between reveal mode and fill mode

-- Define variables
current_size = 0
last_frame = 0
out = true

--Round function (used to round a number to the nearest whole number
function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

-- The pixel function
function pixel(frame, x, y)
    if last_frame ~= frame then -- Do this on each new frame
        -- Get a new size for the circle based upon the proportion through the effect and a sin function
        current_size = round(((math.sin(((frame / frames)* math.pi*2) - math.pi/2)+1)/2) * Max_Radius)
        last_frame = frame
    end
    if dist_from_center(x,y) <= current_size then -- If the distance of the current pixel from the centre is less than the current size it is in the circle
        if Reveal then -- Reveal mode, so the colour is based on the relationship between the distance from the centre and the maximum radius
            return Foreground:lookup(dist_from_center(x,y) / Max_Radius)
        else -- Fill mode, so the colour is based on the relationship between the distance from the centre and the current size (all the gradient is visible)
            return Foreground:lookup(dist_from_center(x,y) / current_size)
        end
    else -- Otherwise output the background colour
        return Background
    end
end

--[[
Copyright 2016 Pharos Architectural Controls Limited. All rights reserved.

This sample content is made freely available for illustrative purposes only. Pharos Architectural Controls grants a non-exclusive copyright licence to use this sample content from which you can generate content tailored to your own specific needs for use with products from Pharos Architectural Controls. This sample content has not been thoroughly tested under all conditions and Pharos Architectural Controls cannot guarantee reliability or serviceability.

This sample content is provided "as is" without warranties of any kind. The implied warranties of non-infringement, merchantability and fitness for a particular purpose are expressly disclaimed. In no event shall Pharos Architectural Controls be liable to any party for direct, indirect, incidental or consequential damages arising from the use of this sample content.

For further information please contact support@pharoscontrols.com.
--]]